function x = generateinput(Randomize)

%generates the input for the next step 

global BIAS INHIB LEAK DT_VM EE EI EL GAMMA THETA TIMESTEP NUMLAYERS NUMNEURONS NUMLAGS LAGLENGTH ITEMLENGTH NUMWM TDU TDUWEIGHT STARTVAL TEMPDELTATHRESH KNOCKOUTTHRESH PERMTHRESH TEMPRATE PERMRATE NUMSTREAMS NUMITEMS VARIANCE BASE
global Neurons Axons Inputvector Retina1 Retina2 colornaming

global Trialnum Lasttrialnum Thisvariance Inputstream Stepnumber Streamanswers STROOPINPUT stroops NUMSTREAMS TRIALDISTRIBUTION Trialtypes val step BIASVARIANCE

%                    Ink       Word
%                    C C C   C C C N N E E



if(Trialnum ==1 & Lasttrialnum == 0)  %first run
'Generating the input block'    
    if(Randomize >0 )     %stroop patterns are found in strooppats
        STROOPINPUT(:,:)  = stroops{Randomize};  
    else
        if(colornaming)
            %cong
            trialtypes(1,:) = [1,0,0,   1,0,0,0,0,0,0];
            %            incong
            trialtypes(2,:) = [1,0,0,   0,1,0,0,0,0,0];
            %neutral
            trialtypes(3,:) = [1,0,0,   0,0,0,1,0,0,0];
            %     neutral
            trialtypes(4,:) = [1,0,0,   0,0,0,0,0,1,0];

        else   %Algom word task
%            Neutral word
            trialtypes(1,:) = [0,0,0,   1,0,0,0,0,0,0];
            %            Emo Word
            trialtypes(2,:) = [0,0,0,   0,1,0,0,0,0,0];
        end



        for(i = 1:NUMSTREAMS)
                type = rand;
                found = 0;
                ontype = 1;
                while(found ==0)
                    if(ontype==1)
                        typea = 0;
                    else
                        typea = TRIALDISTRIBUTION(ontype-1);
                    end
                    typeb = TRIALDISTRIBUTION(ontype);
                    
                    if(type >= typea & type < typeb);
                        found =1;
                        thistype = ontype;
                    end
                    ontype = ontype + 1;
                end
                STROOPINPUT(i,:) = trialtypes(thistype,:);
                Trialtypes(i) = thistype;
        end
    end
end



if(Randomize == 0)
    if(Lasttrialnum ~= Trialnum)   %set the variance for this trial
        val = VARIANCE * rand +1;  %additive method
        val = 2*VARIANCE * rand +BASE-VARIANCE
    end
    val = 1;
    
else    
    if(Lasttrialnum ~= Trialnum)   %set the variance for this trial
        val = VARIANCE * rand +1;  %additive method
        val = 2*VARIANCE * rand +BASE-VARIANCE;
    end
val = 1;
end


    
    Thisvariance = 1.05;
    
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     1,0,0,   0,0,0,0,0,1,0;...
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     1,0,0,   1,0,0,0,0,0,0;...
%                     ];
    


for(i = 1:size(STROOPINPUT,1))
    if(colornaming)
        [x Streamanswers(i)] = max(STROOPINPUT(i,1:3));
    else
      [x Streamanswers(i)] = max(STROOPINPUT(i,4:6));
  end
end

               
    Inputstream = STROOPINPUT;
    tempret1 = zeros(1,NUMNEURONS);
    tempret2 = zeros(1,NUMNEURONS);
    Retina1 = zeros(1,NUMNEURONS);
    Retina2 = zeros(1,NUMNEURONS);
  
    if(step > 50)    %delay presentation    
        tempret1(1,1:3) = reshape(Inputstream(Trialnum,1:3),[1,3]) * Thisvariance;
      tempret2(1,1:7) = reshape(Inputstream(Trialnum,4:10),[1,7]) * Thisvariance;

        %copy the data into the retina
        Retina1(1,1:NUMNEURONS) = tempret1;
        Retina2(1,1:NUMNEURONS) = tempret2;
    end
    
        



